// TOOLBOX.cpp : implementation file
//

#include "stdafx.h"
#include "LC.h"
#include "TOOLBOX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTOOLBOX dialog

static CRect rcSmall;
	static CRect rcLarge;
	
CTOOLBOX::CTOOLBOX(CWnd* pParent /*=NULL*/)
	: CDialog(CTOOLBOX::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTOOLBOX)
	m_EGate2 = _T("");
	m_EOX2 = 0;
	m_EOY2 = 0;
	m_EX2 = 0;
	m_rOption = -1;
	//}}AFX_DATA_INIT
}


void CTOOLBOX::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTOOLBOX)
	DDX_Control(pDX, IDC_FRAME, m_Frame);
	DDX_Text(pDX, IDC_EGATE2, m_EGate2);
	DDX_Text(pDX, IDC_EOX2, m_EOX2);
	DDX_Text(pDX, IDC_EOY2, m_EOY2);
	DDX_Text(pDX, IDC_EX2, m_EX2);
	DDX_Radio(pDX, IDC_RFAST, m_rOption);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTOOLBOX, CDialog)
	//{{AFX_MSG_MAP(CTOOLBOX)
	ON_BN_CLICKED(IDC_BAND, OnBand)
	ON_WM_SETCURSOR()
	ON_BN_CLICKED(IDC_BNAND, OnBnand)
	ON_BN_CLICKED(IDC_BOR, OnBor)
	ON_BN_CLICKED(IDC_BNOR, OnBnor)
	ON_BN_CLICKED(IDC_BNOT, OnBnot)
	ON_BN_CLICKED(IDC_BXOR, OnBxor)
	ON_BN_CLICKED(IDC_BXNOR, OnBxnor)
	ON_BN_CLICKED(IDC_BDR, OnBdr)
	ON_BN_CLICKED(IDC_BDL, OnBdl)
	ON_BN_CLICKED(IDC_BUR, OnBur)
	ON_BN_CLICKED(IDC_BUL, OnBul)
	ON_BN_CLICKED(IDC_BUD, OnBud)
	ON_BN_CLICKED(IDC_BLR, OnBlr)
	ON_BN_CLICKED(IDC_BRELEASE, OnBrelease)
	ON_BN_CLICKED(IDC_BLR2, OnBlr2)
	ON_BN_CLICKED(IDC_BSLR, OnBslr)
	ON_WM_PAINT()
	ON_WM_RBUTTONDOWN()
	ON_BN_CLICKED(IDC_BSTART, OnBstart)
	ON_BN_CLICKED(IDC_BEND, OnBend)
	ON_BN_CLICKED(IDC_BDELETE, OnBdelete)
	ON_BN_CLICKED(IDC_BUNEXPAND, OnBunexpand)
	ON_BN_CLICKED(IDC_BEXPAND, OnBexpand)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

BOOL CTOOLBOX::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	((CButton*)GetDlgItem(IDC_BAND))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_AND1)));	
	((CButton*)GetDlgItem(IDC_BNAND))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_NAND1)));	

	((CButton*)GetDlgItem(IDC_BOR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_OR1)));	
	((CButton*)GetDlgItem(IDC_BNOR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_NOR1)));	

	((CButton*)GetDlgItem(IDC_BNOT))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_NOT1)));	

	((CButton*)GetDlgItem(IDC_BXOR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_XOR1)));	
	((CButton*)GetDlgItem(IDC_BXNOR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_XNOR1)));	

	((CButton*)GetDlgItem(IDC_BUR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UR1)));	
	((CButton*)GetDlgItem(IDC_BUL))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UL1)));	
	((CButton*)GetDlgItem(IDC_BDR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_DR1)));	
	((CButton*)GetDlgItem(IDC_BDL))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_DL1)));	

	((CButton*)GetDlgItem(IDC_BUD))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UD1)));	
	((CButton*)GetDlgItem(IDC_BLR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_DLR1)));	
	((CButton*)GetDlgItem(IDC_BLR2))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_1TO2LR1)));	
	((CButton*)GetDlgItem(IDC_BSLR))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_SLR1)));	

	((CButton*)GetDlgItem(IDC_BSTART))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_START1)));	
	((CButton*)GetDlgItem(IDC_BEND))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_END1)));	

	((CButton*)GetDlgItem(IDC_BRELEASE))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_NORMAL1)));	
	((CButton*)GetDlgItem(IDC_BDELETE))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_DELETE)));	

	((CButton*)GetDlgItem(IDC_BEXPAND))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_EXPAND)));	
	((CButton*)GetDlgItem(IDC_BUNEXPAND))->
			SetIcon(::LoadIcon(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_UNEXPAND)));	

	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_NORMAL);
	SetCursor(lhCursor);

	// CG: The following block was added by the ToolTips component.
	{
		m_tooltip.Create(this);
		m_tooltip.Activate(TRUE);

		m_tooltip.AddTool(GetDlgItem(IDC_BAND),"AND Gate");
		m_tooltip.AddTool(GetDlgItem(IDC_BNAND),"NAND Gate");
		
		m_tooltip.AddTool(GetDlgItem(IDC_BOR),"OR Gate");
		m_tooltip.AddTool(GetDlgItem(IDC_BNOR),"NOR Gate");
		
		m_tooltip.AddTool(GetDlgItem(IDC_BNOT),"NOT Gate");
		
		m_tooltip.AddTool(GetDlgItem(IDC_BXOR),"Exclusive Or (XOR) Gate");
		m_tooltip.AddTool(GetDlgItem(IDC_BXNOR),"Exclusive NOR (XNOR) Gate");
		
		m_tooltip.AddTool(GetDlgItem(IDC_BLR),"Left to Right Bridge");
		m_tooltip.AddTool(GetDlgItem(IDC_BUD),"Up to Down Bridge");

		m_tooltip.AddTool(GetDlgItem(IDC_BRELEASE),"Release pointer to normal cursor.");
		m_tooltip.AddTool(GetDlgItem(IDC_BDELETE),"Delete Gates!");
	}



	/*CClientDC dc(this);
	BITMAP bm;
	CDC dcMemory;
	CBitmap bitmap;

	bitmap.LoadMappedBitmap(IDB_BITMAP2,0);
	bitmap.GetObject(sizeof(BITMAP),&bm);

	dcMemory.CreateCompatibleDC(&dc);
	dcMemory.SelectObject(&bitmap);
	
	dc.BitBlt(0,100,bm.bmWidth,bm.bmHeight,&dcMemory,0,0,SRCCOPY);*/


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// CTOOLBOX message handlers

BOOL CTOOLBOX::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	return TRUE;
}


void CTOOLBOX::OnBand() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_AND);
	SetCursor(lhCursor);
	CursorValue=AND;
}

void CTOOLBOX::OnBnand() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_NAND);
	SetCursor(lhCursor);
	CursorValue=NAND;
}

void CTOOLBOX::OnBor() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_OR);
	SetCursor(lhCursor);	
	CursorValue=OR;
}

void CTOOLBOX::OnBnor() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_NOR);
	SetCursor(lhCursor);	
	CursorValue=NOR;
}

void CTOOLBOX::OnBnot() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_NOT);
	SetCursor(lhCursor);	
	CursorValue=NOT;
}

void CTOOLBOX::OnBxor() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_XOR);
	SetCursor(lhCursor);	
	CursorValue=XOR;
}

void CTOOLBOX::OnBxnor() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_XNOR);
	SetCursor(lhCursor);	
	CursorValue=XNOR;
}

void CTOOLBOX::OnBdr() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_DR);
	SetCursor(lhCursor);	
	CursorValue=DR;
}

void CTOOLBOX::OnBdl() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_DL);
	SetCursor(lhCursor);	
	CursorValue=DL;
}

void CTOOLBOX::OnBur() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_UR);
	SetCursor(lhCursor);	
	CursorValue=UR;
}

void CTOOLBOX::OnBul() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_UL);
	SetCursor(lhCursor);	
	CursorValue=UL;
}

void CTOOLBOX::OnBud() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_UD);
	SetCursor(lhCursor);	
	CursorValue=UD;
}

void CTOOLBOX::OnBlr() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_DLR);
	SetCursor(lhCursor);	
	CursorValue=DLR;
}

void CTOOLBOX::OnBlr2() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_1TO2LR);
	SetCursor(lhCursor);	
	CursorValue=_1TO2LR;
}

void CTOOLBOX::OnBrelease() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_NORMAL);
	SetCursor(lhCursor);	
	CursorValue=RLS;
}

void CTOOLBOX::OnBslr() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_SLR);
	SetCursor(lhCursor);	
	CursorValue=SLR;
}

void CTOOLBOX::OnBstart() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_START);
	SetCursor(lhCursor);	
	CursorValue=START;	
}

void CTOOLBOX::OnBend() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_END);
	SetCursor(lhCursor);	
	CursorValue=END;
}

void CTOOLBOX::OnBdelete() 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_DEL);
	SetCursor(lhCursor);	
	CursorValue=_DEL;
}


BOOL CTOOLBOX::PreTranslateMessage(MSG* pMsg)
{
	{
		m_tooltip.RelayEvent(pMsg);
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CTOOLBOX::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	BITMAP bm;
	CDC dcMemory;
	CBitmap bitmap;

	bitmap.LoadMappedBitmap(IDB_BITMAP5,0);
	bitmap.GetObject(sizeof(BITMAP),&bm);
	dcMemory.CreateCompatibleDC(&dc);
	dcMemory.SelectObject(&bitmap);
	dc.BitBlt(2,36,bm.bmWidth,bm.bmHeight,&dcMemory,0,0,SRCCOPY);	
	
	int x =GetSystemMetrics(SM_CXICON);
	int y =GetSystemMetrics(SM_CYICON);
}

void CTOOLBOX::OnRButtonDown(UINT nFlags, CPoint point) 
{
	HCURSOR lhCursor;
	lhCursor=AfxGetApp()->LoadCursor(IDC_NORMAL);
	SetCursor(lhCursor);	
	CursorValue=RLS;	
	CDialog::OnRButtonDown(nFlags, point);
}



void CTOOLBOX::OnBunexpand() 
{
	
	CString sExpand;
	int nResourceID;
	nResourceID=IDC_DIVIDER;

	// First time through, save the dialogs large
	// and small sizes
	if (rcLarge.IsRectNull())
	{
		CRect rcLandmark;
		CWnd* pWndLandmark = GetDlgItem (nResourceID);
		ASSERT(pWndLandmark);	
	
		GetWindowRect (rcLarge);
		pWndLandmark->GetWindowRect (rcLandmark);
	
		rcSmall = rcLarge;
		//rcSmall.bottom = rcLandmark.top;
		rcSmall.right=rcLandmark.left;
	}

		SetWindowPos(NULL, 0, 0, rcSmall.Width(), rcSmall.Height(),
			SWP_NOMOVE | SWP_NOZORDER);
		EnableVisibleChildren();
		
		GetDlgItem(IDC_BEXPAND)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUNEXPAND)->EnableWindow(FALSE);
		GetDlgItem(IDC_In1)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_FRAME)->ShowWindow(SW_HIDE);
}

void CTOOLBOX::OnBexpand() 
{
	//static  CRect rcLarge;
	//static  CRect rcSmall;
	CString sExpand;
	int nResourceID;
	nResourceID=IDC_DIVIDER;

	// First time through, save the dialogs large
	// and small sizes
	if (rcLarge.IsRectNull())
	{
		CRect rcLandmark;
		CWnd* pWndLandmark = GetDlgItem (nResourceID);
		ASSERT(pWndLandmark);	
	
		GetWindowRect (rcLarge);
		pWndLandmark->GetWindowRect (rcLandmark);
	
		rcSmall = rcLarge;
		rcSmall.bottom = rcLandmark.top;
	}

		SetWindowPos(NULL, 0, 0, rcLarge.Width(), rcLarge.Height(),
			SWP_NOMOVE | SWP_NOZORDER);

		EnableVisibleChildren();
		
		GetDlgItem(IDC_BUNEXPAND)->EnableWindow(TRUE);
		GetDlgItem(IDC_BEXPAND)->EnableWindow(FALSE);
		GetDlgItem(IDC_In1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_FRAME)->ShowWindow(SW_SHOW);

}

void CTOOLBOX::EnableVisibleChildren()
{
	// Disable all children not in the current dialog. This prevents
	// tabbing to hidden controls and disables accelerators.

	// Get the first child control
	CWnd *pWndCtl = GetWindow (GW_CHILD);
	CRect rcTest;
	CRect rcControl;
	CRect rcShow;
	
	GetWindowRect(rcShow);
	   
	while (pWndCtl != NULL)
	{
		pWndCtl->GetWindowRect (rcControl);
		
		if (rcTest.IntersectRect (rcShow, rcControl))
			pWndCtl->EnableWindow(TRUE);
		else
			pWndCtl->EnableWindow(FALSE);
		
		// Get the next sibling window in this chain.
		pWndCtl = pWndCtl->GetWindow (GW_HWNDNEXT);
	}

}
